c  include file for boost parameters
c  Byron Roe  Dec. 11, 2003
c  Revised Jan. 21, 2005
      logical training_or_data
      parameter(training_or_data = .false.)  
c  This parameter is true for a data run and false for a training run
      logical boost_bins
c  If boost_bins is true, a binned version of boost is used, otherwise
c  an event version is used.
      parameter (boost_bins = .true.)
      integer ada_or_epsilon,ada,eps
      parameter (ada=1,eps=-1)
c      parameter (ada_or_epsilon=eps)   !use epsilon boost
      parameter (ada_or_epsilon=ada)   !use ada boost
      real epsilon   !This is the small parameter for epsilon boosting
      parameter (epsilon = 0.03)
      real alpha_const   !This is a const multiplying alpha (0.5 is standard)
      parameter (alpha_const = .5)
      logical randomize_training_sample  !If true pick samples for training
c  randomly throughout the given event sample
      parameter (randomize_training_sample=.false.)
      integer random_seed   !This starts the random number generator
      parameter (random_seed =15325)
      integer left,right,no_node,sorted_node
      parameter(left=1,right=-1,no_node=-2,sorted_node=1000)
c  We will use these symbols for left and right branches
c  Set the purity cut for accepting this as a signal node
      real purity_cut  
      parameter (purity_cut = 0.5)
c      parameter (purity_cut = 0.6)
c  This is the number of trees and nodes we will use
      integer max_nodes,max_num_trees,max_leaves
      parameter (max_nodes=89)   !max_nodes must be odd and ge 3
      parameter (max_num_trees=501,
     +           max_leaves=(max_nodes+1)/2)
      integer nvar,nvar_in,nevt_max
c  nvar_in is the number of i.d. variables read in, while nvar is the
c  number of those used for training.  The first nvar of the nvar_in
c  variables are used
       parameter(nvar=50,nvar_in=50,nevt_max=100000)
c  In addition, the input file may have a prefix for each event, assumed
c  to be floating point.  This might be event number ...
       integer nprefix
       parameter (nprefix = 0)
c  The next parameters are used if each tree will use only a fraction
c  of the training sample, selected randomly.
      real fraction_train_for_tree
c  If fraction_train_for_tree is greater then 1, then the entire
c  training sample will be used for each tree. If it is <=1, then
c  that fraction will be used, chosen randomly from the training events.
c      parameter (fraction_train_for_tree = 0.50)
c      parameter (fraction_train_for_tree = 0.99)
      parameter (fraction_train_for_tree = 1.1)
      integer num_train_for_tree,list_train_for_tree(nevt_max)
c The next parameters are used if each node will use only a fraction
c of the total number of variables, selected randomly
      real fraction_var_for_node
c If fraction_var_for_node is greater than 1, then each node will
c use all variables
	parameter (fraction_var_for_node=1.1)
	integer num_var_for_node,list_var_for_node(nvar)
c  Set minimum number of events for a node and minimum number in bin
      integer min_node_size,min_bin_size,min_node
c  For boost_evts,min_node_size = min_node
c  For boost_bins,min_node_size = 2*min_bin_size
      parameter(min_bin_size=100)
c      parameter(min_node = 200)
      parameter(min_node = 20)
c  We will test every kth tree
      integer test_every_kth_tree
      parameter (test_every_kth_tree=25)
      integer num_iterations
      parameter(num_iterations=15)
c  If weight of a node is less than this it is taken as an ending node
      real min_allowed_weight
      parameter(min_allowed_weight=.0)
c  If training_size is non-zero, num_train is set to training_size.
c  If it is zero, then num_train is one_half the smallest of the 2 samples
	integer training_size_sig,training_size_bkrd,training_size_tot
       parameter (training_size_sig=15000)
       parameter (training_size_bkrd=20000)
c       parameter (training_size_bkrd=5000)
       parameter (training_size_tot = training_size_sig
     +                                +training_size_bkrd)
c if choosing training events without replacement (the standard method)
c without_replacement is true, if with replacement, it is false.
	logical without_replacement
	parameter(without_replacement = .true.)
c special parameter for "random forest"--no weight updating
c if weight_wrong_evts is false, no weighting of wrong events will occur
	logical weight_wrong_evts
	parameter(weight_wrong_evts = .true.)
c
c   Special parameters for version of boost using bins, not events
      integer num_bins
      parameter(num_bins = 100)
c  Events with weights less than trim*average weight are not used
c  in making up the tree.  Set trim_wgt to 0., if trimming not desired.
c  For this program version leave trim_wgt = 0,
      real trim_wgt
      parameter(trim_wgt= .0)
      logical soft_score
      parameter(soft_score =.true.)
c  If soft_score is false, then score is -1 for purity <1/2 and +1 otherwise
c  If soft_score is true, then score is a continuous function of purity
c  soft_score = .true. is recommended.
c  End of parameters
c
