c Fortran program boost for making boosted decision trees
c Boost_evts
c Byron Roe Dec. 11, 2003
c Revised Jan. 20,2004
c Revised Mar. 30,2004
c Revised May 14,2004
c Revised June 8,2004
c Revised July 29,2004
c Revised Aug. 18, 2004
c Revised Oct. 8, 2004
c Revised Feb. 7, 2005
c Revised Dec. 9, 2005
      program boost
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer ievt,itree,ivar
      real temp
      integer ijklin,n_ntup,ind1,ind2
      parameter (n_ntup=66)
      ijklin = random_seed
      done = .false.
      if (.not.training_or_data) then
c  Here for a training run
c         if (min_node .ne. 0) then
c            write(*,*)'I am in the wrong place, training_or_data = ',
c     +         training_or_data
c            stop
c         end if
           
         min_node_size = min_node
         if (boost_bins) min_node_size = 2*min _bin_size
c     ijklin is the seed for ranlux, the random number program in
C     boone_nuspek
         call do_boost_hbook(1) !Initialize hbook     Here to initialize ntuple
         call output_var(0,0.)
c     Initialize  random number generator
         call rluxgo(3,ijklin,0,0)
         write (*,*)
     +        ,' randomize_training_sample =',randomize_training_sample
     +        ,'  random_seed =',random_seed
         write(40,*)
c     +    ,' randomize_training_sample =',randomize_training_sample
     +        ,'random_seed =',random_seed
         call readin_data
         call sort_data
c     Initialize the weights--sum weight is 1/2 for sig and 1/2 for bkrd
         temp = .5/float(num_train_sig)
         do ievt = 1,num_train_sig
            weight(ievt) = temp
         end do                 !ievt = 1,num_train_sig
         temp = .5/float(num_train_bkrd)
         do ievt = num_train_sig+1,num_train_tot
            weight(ievt) = temp
         end do                 !ievt = num_train_sig+1,num_train_tot
c***  Temp. Kludge--give bkrd more initial weight than signal
c     do ievt = num_train_sig+1,num_train_tot
c     weight(ievt) = 1.*temp
c     end do   !ievt = num_train_sig+1,num_train_tot
c     temp = 0.
c     do ievt = 1, num_train_tot
c     temp = temp + weight(ievt)
c     end do   !ievt = 1, num_train_tot
c     do ievt = 1, num_train_tot
c     weight(ievt) = weight(ievt)/temp
c     end do   !ievt = 1, num_train_tot
c***  End temp Kludge
c     Set up the number of training events used for each tree and the
c     number of variables used for each node of each tree.
         num_train_for_tree = num_train_tot
         num_available_sig = num_train_sig
         num_available_bkrd = num_train_bkrd
         num_available = num_available_sig + num_available_bkrd
         do ievt = 1, num_train_tot
            list_train_for_tree(ievt) = 1
            list_available(ievt) = ievt
         end do                 !ievt = 1, num_train_tot
         write(*,*) 'number training events for each tree = ',
     +        int(float(num_train_for_tree)
     +        *(amin1(fraction_train_for_tree,1.)))
         if (fraction_var_for_node .gt. 1.) then
            num_var_for_node = nvar
            do ivar = 1,nvar
               list_var_for_node(ivar) = ivar
            end do              !ivar = 1,nvar
         else
            num_var_for_node = fraction_var_for_node*nvar
         end if
         write(*,*) 'number of variables at each node = ',
     +        num_var_for_node  
c     zero out the linking variables
         do ind1 = 1,max_num_trees
            do ind2 = 1, max_nodes
               next_left_node(ind2,ind1) = no_node
               next_right_node(ind2,ind1) = no_node
               previous_node(ind2,ind1) = no_node
            end do
         end do
         call vzero(node_var,max_nodes*max_num_trees)
         call vzero(node_val,max_nodes*max_num_trees)
         call vzero(purity_left,max_nodes*max_num_trees)
         call vzero(purity_right,max_nodes*max_num_trees)
c     Loop over trees
         write(*,*) 'starting loop over trees'
         do itree = 1, max_num_trees
            call make_tree(itree)
            call update_weights(itree)
c     call update_weights2(itree)
            if (mod(itree,test_every_kth_tree).eq.1) 
     +           call check_purity(itree)
         end do                 !itree = 1, num_trees_to_use
         call do_boost_hbook(2) !Readout hbook
         if (ada_or_epsilon .eq. eps) then
            write(*,*)'epsilon boost, epsilon = ',epsilon
            write(40,*)'epsilon boost, epsilon = ',epsilon
         else
            write(*,*) 'ada boost, ada constant =', alpha_const
            write(40,*) 'ada boost, ada constant =', alpha_const
         end if
         write(*,*)'randomize training sample = '
     +        ,randomize_training_sample
     +        ,' random seed',random_seed, 'num variables =',nvar
     +        ,' fraction training sample for each tree = '
     +        ,fraction_train_for_tree,
     $        ' fraction of variables for each',' node = '
     $        ,fraction_var_for_node,
     $        ' number training signal events = ', num_train_sig,
     $        ' number of training bkrd events = ',num_train_bkrd
     $        ,' number of test signal events = ',num_sig -
     $        num_train_sig,' number of test bkrd events = ',num_bkrd -
     $        num_train_bkrd 
         write(40,*)'randomize training sample = '
     +        ,randomize_training_sample
     +        ,' random seed',random_seed, 'num variables =',nvar
     +        ,' fraction training sample for each tree = '
     +        ,fraction_train_for_tree,
     $        ' fraction of variables for each',' node = '
     $        ,fraction_var_for_node,
     $        ' number training signal events = ', num_train_sig,
     $        ' number of training bkrd events = ',num_train_bkrd
     $        ,' number of test signal events = ',num_sig -
     $        num_train_sig,' number of test bkrd events = ',num_bkrd -
     $        num_train_bkrd 
         write(*,*) max_num_trees, ' trees,  ',max_nodes, ' nodes',
     +        max_leaves,' leaves','  purity_cut is ',purity_cut,
     +        '  min_allowed_weight is ',min_allowed_weight, 
     +        'trim_wgt is',trim_wgt, 
     +        'RATIO FOR 10-90% ',
     +        ' signal kept is ',ratio
         write(40,*) max_num_trees, ' trees,  ',max_nodes, ' nodes',
     +        max_leaves,' leaves','  purity_cut is ',purity_cut,  
     +        '  min_allowed_weight is ',min_allowed_weight,  
     +        'trim_wgt is',trim_wgt, 
     +        '  RATIO FOR 10-90%',
     +        ' signal kept is ',ratio
      else
c     Here for a data run
         call readin_data
         call data_loop_over_trees
      end if
      stop
      end
c-----------------------------------------------------------------------
      subroutine readin_data
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer ievt1,ievt_sig,ievt_bkrd,ievt_train,ivar,i
      integer choose_for_train(nevt_max),num_sample,num_data_temp
      integer nfiles_in,nfiles_use,ifile,istat,nvar_temp
     +                 ,num_file_tree_old_temp,ievt_data,ievt_train0
      real dum
      include 'boost_files.inc'
      if (.not.training_or_data) then
c  Here for training run
        write(*,*) 'file_sig(1)',file_sig(1)
        open(21,file=file_sig(1),status='old')
        read(21,*) num_sig,num_bkrd
        write(*,*) num_sig,num_bkrd
        if (training_size_sig+training_size_bkrd .eq. 0) then
           num_train_sig = min0(num_sig,num_bkrd)/2
           num_train_bkrd = num_train_sig
           num_train_tot = 2*num_train_sig
        else
           num_train_sig = training_size_sig
           num_train_bkrd = training_size_bkrd
           num_train_tot = training_size_tot
        end if
        if ((num_train_sig .ge. (num_sig-500)).or.
     +       (num_train_bkrd .ge.(num_bkrd-500))) go to 70
        num_sample = num_sig
        call choose_train_evts(choose_for_train,num_sample,num_train_sig
     $       )
c     select a scrambled training set
        ievt_sig = 1
        ievt_bkrd = 1
        ievt_train = 1
        do ievt1 = 1,num_sig
           if (choose_for_train(ievt1) .eq. 0) then
c     Test event
              if (nprefix .gt. 0) then
                 read(21,*,err=100) (prefix(i,ievt_sig),i=1,nprefix)
              end if

              read(21,*,err=100) (test_dat_sig(ievt_sig,ivar)
     +             ,ivar=1,nvar_in)
              ievt_sig = ievt_sig + 1
           else
c     Training event
              if (nprefix .gt. 0) then
                 read(21,*,err=100) (prefix(i,ievt_train),i=1,nprefix)
              end if 

              read(21,*,err=100) (train_dat(ievt_train,ivar),ivar=1
     +             ,nvar_in)
              ievt_train = ievt_train + 1
           end if
        end do                  !ievt1 = 1,num_sig
        num_sample = num_bkrd
        call choose_train_evts(choose_for_train,num_sample
     $       ,num_train_bkrd)
c     select a scrambled training set
        ievt_train0 = ievt_train
        do ievt1 = 1,num_bkrd
           if (choose_for_train(ievt1) .eq. 0) then
c     Test event
              if (nprefix .gt. 0) then
                 read(21,*,err=100) (prefix(i,ievt_bkrd),i=1,nprefix)
              end if

             read(21,*,err=100) (test_dat_bkrd(ievt_bkrd,ivar)
     +             ,ivar=1,nvar_in)
              ievt_bkrd = ievt_bkrd + 1
           else
c     Training event
              if (nprefix .gt. 0) then
                 read(21,*,err=100) (prefix(i,ievt_train),i=1,nprefix)
              end if


              read(21,*,err=100) (train_dat(ievt_train,ivar)
     +             ,ivar=1,nvar_in)
              ievt_train = ievt_train + 1
           end if
        end do                  !ievt1 = 1,num_bkrd
 22     continue
        write(*,*) 'num_sig,num_bkrd,num_train_sig,num_train_bkrd',
     +       'num_train_tot',num_sig,num_bkrd,num_train_sig
     $       ,num_train_bkrd,num_train_tot
        write(40,*) 'num_sig,num_bkrd,num_train_sig,num_train_bkrd',
     +       'num_train_tot',num_sig,num_bkrd,num_train_sig
     $       ,num_train_bkrd,num_train_tot
        return
c     Get to this section on too many training events
 70     write(*,*)'Too many training evts--sig,bkrd,trainsig,trainbkrd,'
     +       ,'num_train_tot='
     +       ,num_sig,num_bkrd, num_train_sig,num_train_bkrd
     $       ,num_train_tot
        stop
c     Get to this section on error in number of events to read in
 100    write(*,*)  'Error on readin numbers! num_sig,num_bkrd,'
     +       ,'num_train_sig,num_train_bkrd,ievt1 = '
     +       , num_sig,num_bkrd,num_train_sig,num_train_bkrd,ievt1 
        stop
      else  !Here for data run
         write(*,*) 'I am at the start of readin for data'
         num_data = 0
         if (num_file_data .le.0) then
            write(*,*) 'Error, data run but num_file_data is = 0'
            stop
         end if
         do ifile = 1,num_file_data
            open(30+ifile,file=file_data(ifile),form='FORMATTED'
     +           ,status='old')
            read (30+ifile,*) num_data_temp,num_file_tree_old_temp,
     +          nvar_temp
            write(*,*)'num_data in file ',file_data(ifile),' is '
     +            ,num_data_temp
            write(*,*) 'num_file_tree_old_temp = '
     +        ,num_file_tree_old_temp,' nvar_temp ',nvar_temp
            num_data = num_data + num_data_temp
c 	    read(30+ifile) num_file_tree_old_temp
c	    read(30+ifile) nvar_temp;
            if (nvar_temp.gt.nvar_in) then
               write(*,*)'error--nvar_in = ',nvar_in,'nvar_temp = ',
     +                   nvar_temp
               stop
            end if
            if ((ifile.gt.1).and.(num_file_tree_old_temp .ne.
     +           num_file_tree_old)) then
               write(*,*) 'Error--Unmatch number of existing sum_T_m',
     +          '_dat',num_file_tree_old,num_file_tree_old_temp
               stop
            end if
            num_file_tree_old = num_file_tree_old_temp
            do ievt_data = 1,num_data_temp
               if (nprefix .gt.0) then
                     read(30+ifile,*)(prefix(i,ievt_data),i=1,nprefix)
               end if  !nprefix
               if (num_file_tree_old .gt. 0) then
                  read(30+ifile,*) (sum_T_m_dat(i,ievt_data),i=1,
     +             num_file_tree_old)
               end if  ! if old tree files
c               write(*,*) 'I got to reading ivar'
               read(30+ifile,*) (event_dat(ievt_data,ivar)
     +                 ,ivar=1,nvar_in)
            end do  !loop over ievt_data
            close(30+i)
        end do  !end loop over data files
      end if  !training or data
      end
c-----------------------------------------------------------------------
      subroutine choose_train_evts(choose_for_train,num_sample,ntrain)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer choose_for_train(nevt_max),num_sample
      integer ievt,iselect,ntrain
      real myran_sing,float_sample,dum
      call vzero(choose_for_train,num_sample)
      if (randomize_training_sample) then
         ievt = 1
         float_sample=float(num_sample)
c         write(*,*)  'I got to 1,float_sample =',float_sample
 20      iselect = int((myran_sing(dum)+1.e-4)*float_sample)
        iselect = min0(iselect,num_sample)
         iselect = max0(iselect,1)
c         write(*,*) ievt,iselect,choose_for_train(iselect)
         if (choose_for_train(iselect).eq.1) go to 20 !choose again
         choose_for_train(iselect) = 1
         if (ievt .eq. ntrain) go to 100
         ievt = ievt + 1
         go to 20
c         write(*,*) 'I got to 2'
      else   !do not pick events randomly
         do ievt = 1,ntrain
            choose_for_train(ievt) = 1
         end do
      end if
 100  return
      end      
c-----------------------------------------------------------------------
      subroutine sort_data
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer ivar,j,index
      do ivar=1,nvar
         call sortzv(train_dat(1,ivar), 
     +           sorted_index_train(1,ivar),num_train_tot,1,0,0)
c   Sort the data in ascending order and store results in
c   sorted_index_train
      end do
c        write(*,*) 'sort',((ivar, train_dat(sorted_index_train(j,ivar)
c     +             ,ivar ),j=1,10),
c     +               ivar=1,5)
      write(*,*)  'data sorted'
      do j = 1,num_train_tot
         do ivar = 1,nvar
            index = sorted_index_train(j,ivar)
            if (index .le. num_train_sig) then
               call hfill(ivar,train_dat(index,ivar),0.,1.)
            else
               call hfill(ivar+100,train_dat(index,ivar),0.,1.)
            end if
         end do   !ivar = 1,nvar
      end do      !j = num_train_tot
      return
      end
c-----------------------------------------------------------------------
      subroutine make_tree(itree)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer inode,itree,leftright,inode_test,inode_best,last_node
     +   ,ind1,ind2,ievt
      real purity_change_best,purity_change_test,temp,temp_best
       do ind1 = 1, max_nodes
         leftright_from_parent(ind1) = no_node
         cut_crit_node(ind1) = 0.
         weight_tot(ind1) = 0.
         weight_left_leaf_var(ind1) = 0.
         weight_right_leaf_var(ind1) = 0.
      end do
      do ind2 = 1, 2*nevt_max
         evt_last_node(ind2) = no_node
         leftright_from_last(ind2) = 0
      end do
c  If only using a fraction of the training events for each tree, choose
c  the event sample now.
c      write(*,*)  'calling choose_tree_events'
      if ((fraction_train_for_tree .le. 1.).or.(trim_wgt.gt.0.)) 
     +              call choose_tree_evts
c      write(*,*) 'past choose tree_events'
c  Now find weight including possible effect of choosing "with 
c  replacement" which means list_train_for_tree can be >1
      do ievt = 1, num_train_tot
         weight2(ievt) = weight(ievt)*float(list_train_for_tree(ievt))
      end do
      inode = 1
      leftright = left
      leftright_from_parent(1)= left
      previous_node(1,itree) = no_node
         call make_node(inode,itree)
      do inode = 1, max_nodes-2,2
c Must find which node to use next.  We have already split them, but
c will decide which to add and then will make new nodes at both left
c and right branches of selected node.  Pick the node maximizing the
c change in sensitivity, which I define as purity(1-purity) of previous 
c node - cut_crit_node.
c
c Search over all nodes up to now
         if (inode .eq. 1) then
            inode_best = 1
            go to 50            !just make the next nodes
         end if
         purity_change_best = -1.e17
         do inode_test = 2,inode
c           if ((next_left_node(inode_test,itree).eq.sorted_node).and.
c     +      (next_right_node(inode_test,itree).eq.sorted_node)) go to 10
            last_node = previous_node(inode_test,itree)
            if ((next_left_node(inode_test,itree) .eq. no_node) .and.
     +         (next_right_node(inode_test,itree) .eq. no_node)
     +         .and.(weight_tot(inode).ge.min_allowed_weight)) then
c  Have found an ending node with weight greater than minimum.
               last_node = previous_node(inode_test,itree)
               if (leftright_from_parent(inode_test) .eq. left) then
                  purity_change_test = purity_left(last_node,itree)*(1.
     $                 - purity_left(last_node,itree))
     $                 *weight_left_leaf_var(last_node)-
     $                 cut_crit_node(inode_test)*weight_tot(inode_test)
               else   !from right leaf
                  purity_change_test = purity_right(last_node,itree)*(1.
     $                 - purity_right(last_node,itree))
     $                 *weight_right_leaf_var(last_node)-
     $                 cut_crit_node(inode_test)*weight_tot(inode_test)
               end if   !from left or right leaf
               if ((purity_change_test .gt. purity_change_best)
     +           .and.(cut_crit_node(inode_test).ne.0.)) then
                  inode_best = inode_test
                  purity_change_best = purity_change_test
               end if   !test if best purity change
            end if   !test if ending node
 10         continue
         end do  !inode_test = 1,inode
c         write(*,*) 'inode best,delta p',inode_best,purity_change_best
c         write(*,*) 'last_node,cut_crit_node',
c     $        last_node,cut_crit_node(inode_best)
c  Now know which node to use.  Link it
         if (purity_change_best .lt. -1.e10) ! no good nodes to be found
     +        return  !cut off tree at this point
 50      previous_node(inode+1,itree) = inode_best
         previous_node(inode+2,itree) = inode_best
         next_left_node(inode_best,itree) = inode + 1
         next_right_node(inode_best,itree) = inode + 2
         leftright_from_parent(inode+1) = left
         leftright_from_parent(inode+2) = right
c         write(*,*) 'inode,inode_best',inode,inode_best
         call make_node(inode+1,itree)
c         write(*,*) 'called make_node with inode = ',inode+1
         if (next_left_node(inode+2,itree).ne.sorted_node) then
            call make_node(inode+2,itree)
         end if
c         write(*,*) 'called make_node with inode = ',inode+2        
      end do   !inode = 1, max_nodes-2,2
c      write(*,*) 'made tree number', itree
c      write(*,*) ' alpha_m = ', alpha_m(itree)
c   Temporary write section
c      write(*,*) '********Tree number ',itree,' *********'
c      do inode = 1, max_nodes
c         write(*,*) 'node,prev,nextleft,nextright,leftright',
c     +     inode,previous_node(inode,itree),next_left_node(inode,itree) 
c     +     ,next_right_node(inode,itree),leftright_from_parent(inode)
c      end do
 100  return
      end
c-----------------------------------------------------------------------
      subroutine choose_tree_evts
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer num_s,num_b,iselect,ievt,num_tot
      real float_num_sig,float_num_bkrd,dum,myran_sing,float_num_tot
      num_s = min0(ifix(fraction_train_for_tree*float(num_available_sig)
     +                ),num_available_sig)
      num_b = min0(ifix(fraction_train_for_tree
     +               *float(num_available_bkrd)),num_available_bkrd)
      num_tot = num_s+num_b
c      write(*,*) ' I am at choose_tree_events,num_s,num_b',num_s,num_b
c      write(*,*) 'num_train_sig,num_s,num_b',num_train_sig,num_s,num_b
      call vzero(list_train_for_tree,nevt_max)
c  For now pick fraction of total not same fraction signal and background
      float_num_sig = float(num_available_sig)
      float_num_bkrd = float(num_available_bkrd)
      float_num_tot = float_num_sig+float_num_bkrd
      if (num_tot .le. 0) go to 100
      if ((fraction_train_for_tree .gt. 1.).or.((fraction_train_for_tree
     +    .eq. 1).and. without_replacement))   then
c      if (num_s .eq. num_available_sig) then
         do ievt = 1,num_available
            list_train_for_tree(list_available(ievt)) = 1
         end do   !ievt = 1,num_train_sig
         go to 100
      end if
      if ((float(num_tot) .lt. (.5*float_num_tot)
     +     ).or.(.not.without_replacement)) then
         ievt = 1
 20      iselect = int ((myran_sing(dum)+1.e-4)*float_num_tot)
         iselect = min0 (iselect,num_available)
         iselect = max0 (iselect,1)
         if (without_replacement) then
            if (list_train_for_tree(list_available(iselect)) .eq. 1) 
     +          go to 20   !choose again
            list_train_for_tree(list_available(iselect)) = 1
            if (ievt .eq. num_tot) go to 100
            ievt = ievt + 1
            go to 20
         else
            list_train_for_tree(list_available(iselect)) =
     +           list_train_for_tree(list_available(iselect))+1
            if (ievt .eq. num_tot) go to 100
            ievt = ievt+1
            go to 20
         end if
      else  !fraction more than 1/2 and without replacement is true
         do ievt = 1,num_available
            list_train_for_tree(list_available(ievt)) = 1
         end do   !ievt = 1,num_available
         ievt = 1
 25      iselect = int ((myran_sing(dum)+1.e-4)*float_num_tot)
         iselect = min0 (iselect,num_available)
         iselect = max0 (iselect,1)
         if (list_train_for_tree(list_available(iselect)) .eq. 0) 
     +          go to 25   !choose again
         list_train_for_tree(list_available(iselect)) = 0
         if (ievt .ge. num_available -num_tot) go to 100
         ievt = ievt + 1
         go to 25
      end if
 100  continue
      end

c-----------------------------------------------------------------------
      subroutine choose_node_var
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer iselect,ivar,list_temp(nvar)
      real float_nvar,myran_sing,dum
      call vzero(list_temp,nvar)
c
      float_nvar = float(nvar)
c pick variables 
      ivar = 1
 20   iselect = int ((myran_sing(dum)+1.e-4)*float_nvar)
      iselect = min0 (iselect,nvar)
      iselect = max0 (iselect,1)
      if ((list_temp(iselect) .eq. 1).and.(without_replacement))
     +                         go to 20   !choose again
      list_temp(iselect) = 1
      list_var_for_node(ivar) = iselect
      if (ivar .ge. num_var_for_node) go to 100
      ivar = ivar + 1
      go to 20
 100  return
      end
c-----------------------------------------------------------------------
      subroutine make_node(inode,itree)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer ivar,ievt,best_var,inode,itree,nsig,nbkrd
     +   ,last_node,kvar,kevt
      real best_value,weight_sig_temp,weight_bkrd_temp
     +     ,wgt_index_sig,wgt_index_bkrd
      real var_max(nvar),var_min(nvar)
      common/make_node_local/var_max,var_min,best_var,best_value
     +     ,weight_sig_temp,weight_bkrd_temp,nsig,nbkrd,last_node
c  First find the total signal and bkrd weights for this node
c      write(*,*) 'weight_sig,bkrd last = ',weight_sig_temp
c     + ,weight_bkrd_temp 
      weight_sig_temp = 0.
      weight_bkrd_temp = 0.
      nsig = 0
      nbkrd = 0
      last_node = previous_node(inode,itree)
c      write(*,*) 'calling choose_node_var'
      if (fraction_var_for_node .le. 1.) call choose_node_var
      do ivar = 1,num_var_for_node
         var_max(list_var_for_node(ivar)) = -1.e20
         var_min(list_var_for_node(ivar)) = 1.e20
      end do  !ivar
c      write(*,*) 'past choose_node_var'
      do kevt = 1,num_available
         ievt = list_available(kevt)
         if (list_train_for_tree(ievt) .eq.0) go to 400
         if ((last_node .eq. no_node).or.(last_node .eq. sorted_node) 
     +      .or. ((evt_last_node(ievt).eq.last_node)
     +      .and.(leftright_from_last(ievt).eq.
     +       leftright_from_parent(inode))))  then
            do kvar = 1,num_var_for_node
               ivar = list_var_for_node(kvar)
               var_max(ivar) = max(var_max(ivar),train_dat(ievt,ivar))
               var_min(ivar) = min(var_min(ivar),train_dat(ievt,ivar))
            end do
            if (ievt .le. num_train_sig) then
               weight_sig_temp = weight_sig_temp + weight2(ievt)
               nsig = nsig + 1
            else
               weight_bkrd_temp =weight_bkrd_temp + weight2(ievt)
c For choosing with replacement, list can be >1
               nbkrd = nbkrd + 1
            end if
         end if      
  400     continue
      end do   !ievt = 1, num_train_tot
c         write(*,*) 'inode,weight_sig,bkrd now = ',inode,weight_sig_temp
c     +        ,weight_bkrd_temp 

      weight_tot(inode) = weight_sig_temp + weight_bkrd_temp
c      if ((inode.gt.11).and.(inode.lt.16))
c     +write(*,*) 'inode,nsig,nbkrd,wt_sig_temp,wt_bkrd_temp, wt_tot',
c     +'last_node = ',inode
c     + ,nsig,nbkrd,weight_sig_temp,weight_bkrd_temp,weight_tot(inode)
c     +,last_node
      if ((weight_sig_temp .eq. 0.) .or. (weight_bkrd_temp .eq. 0.) .or. 
     +     ((nsig + nbkrd) .lt. min_node_size)) then
c  Completely sorted or empty or less than min size.  Quit
c         write(*,*) 'at empty--inode,itree,weight_sig,bkrd,nsig,nbkrd',
c     +        inode,itree,weight_sig_temp,weight_bkrd_temp,nsig,nbkrd
c         write(*,*)'min node size = ',min_node_size
         next_left_node(inode,itree) = sorted_node
         next_right_node(inode,itree) = sorted_node
         if ((weight_sig_temp+weight_bkrd_temp) .gt.0.) then
            purity_left(inode,itree) = weight_sig_temp
     +                               /(weight_sig_temp+weight_bkrd_temp)
         else
            purity_left(inode,itree) = 0.
c  If no events, set companion node sorted as well.
            if (inode .lt. max_nodes) then
               if (mod(inode,2).eq.0) then
c set node+1 to 0
                  next_left_node(inode+1,itree) = sorted_node
                  next_right_node(inode+1,itree) = sorted_node
                  purity_left(inode+1,itree) = 0.
c     +               purity_left(previous_node(inode),itree)
                  purity_right(inode+1,itree) = 0.
               else   ! set node-1 to 0
                  next_left_node(inode-1,itree) = sorted_node
                  next_right_node(inode-1,itree) = sorted_node
                  purity_left(inode-1,itree) = 0.
c     +               purity_left(previous_node(inode),itree)
                  purity_right(inode-1,itree) = 0.
               end if
            end if
         end if
         return
      end if   !ending node
c      write(*,*) 'inode,weight_tot',inode,weight_tot(inode)
      if (boost_bins) then
         call make_node2_bins(inode,itree)
      else
         call make_node2_evts(inode,itree)
      end if
c  At this point we have the best cut, know the variable, and weights
c  Set logical variable telling whether events are at the next
c  left  or right node.
      node_var(inode,itree) = best_var
      node_val(inode,itree) = best_value
c      write(*,*) 'inode ',inode,' itree ',itree,
c     +' best_value = ',best_value,' best var = ',best_var
c      ,'min_size',min_bin_size,min_node_size
c       if ((inode .gt. 11).and.(inode.lt.16))
c     + write(*,*)'node',inode,'cut_crit',cut_crit_node(inode  
c     +   ),'pur_right'
c     +  ,purity_right(inode,itree)
c     +,'pur_left',purity_left(inode,itree),'wgt_right'
c     +  ,weight_right_leaf_var(inode),'wgt_left' 
c     +  ,weight_left_leaf_var(inode)
c
      if (inode .eq. max_nodes) return 
      do ievt = 1,num_train_tot
         if (list_train_for_tree(ievt) .eq.0) go to 401
         if ((inode.eq.1) .or. 
     +        ((evt_last_node(ievt).eq.last_node).and.
     +        (leftright_from_last(ievt)
     +        .eq.leftright_from_parent(inode))))  then
            evt_last_node(ievt) = inode
            if (train_dat(ievt,best_var) .lt. best_value) then
               leftright_from_last(ievt) = left
            else
               leftright_from_last(ievt) = right
           end if
         end if
 401     continue
      end do   !ievt = 1,num_train_tot 
c      write(*,*) 'node,signalweight--left,right,tot',inode,
c     +    weight_left_leaf_sig_var,weight_sig_temp-
c     +     weight_left_leaf_sig_var,weight_sig_temp
c      write(*,*) 'node,bkrdweight--left,right,tot',inode,
c     +    weight_left_leaf_bkrd_var,weight_bkrd_temp-
c     +     weight_left_leaf_bkrd_var,weight_bkrd_temp
c      write(*,*) 'node,totweight--left,right',inode,
c     +    weight_left_leaf_var(inode),weight_right_leaf_var(inode)
c     +   ,weight_tot(inode)
c      write(*,*) 'purity-left,right', purity_left(inode,itree)
c     +   , purity_right(inode,itree) 
      return
      end
c-----------------------------------------------------------------------
      subroutine make_node2_bins(inode,itree)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer ivar,ievt,index,best_var,inode,itree,nsig,nbkrd
     +   ,last_node,kvar,kevt
      real value, weight_left_leaf_sig,weight_right_leaf_sig
     +     ,weight_left_leaf_bkrd,weight_right_leaf_bkrd
     +     ,temp_purity_left,temp_purity_right
     +     ,weight_bkrd_temp,weight_left_leaf_sig_var
     +     ,weight_left_leaf_bkrd_var,weight_left_leaf
     +     ,weight_right_leaf,best_value,weight_sig_temp
     +     ,wgt_index_sig,wgt_index_bkrd,temp_cut_crit
      common/make_node_local/var_max,var_min,best_var,best_value
     +     ,weight_sig_temp,weight_bkrd_temp,nsig,nbkrd,last_node
c  Special variables for version of boost using bins, not events
      real wgt_in_bin_sig(num_bins,nvar),wgt_in_bin_bkrd(num_bins,nvar)
     +     ,var_max(nvar),var_min(nvar),step(nvar),wgt_temp_bkrd
     +     ,wgt_temp_sig,bin_value(num_bins+1,nvar)
      integer
     +     num_evts_in_bin,num_temp_bkrd,num_temp_sig,num_bin_temp_max
     +     ,ihalf,num_per_bin,num_in_bin
      real value_test,wgt_bin_evts_sig(nevt_max),val_bin_evts(nevt_max)
     +     ,wgt_bin_evts_bkrd(nevt_max),weight_temp
      integer imix,nmix,num_local,nbin_max,nbinj(nvar),ibin
c  Now make up the bins
      num_per_bin = max0((nsig+nbkrd)/num_bins,min_bin_size)
      num_bin_temp_max = min0((nsig + nbkrd)/num_per_bin,num_bins)
      if (num_bin_temp_max .le. 1) then
c  Declare this an ending node
         next_left_node(inode,itree) = sorted_node
         next_right_node(inode,itree) = sorted_node
         if ((weight_sig_temp+weight_bkrd_temp) .gt.0.) then
                    purity_left(inode,itree) = weight_sig_temp
     +                            /(weight_sig_temp+weight_bkrd_temp)
         else
            purity_left(inode,itree) = 0.
         end if   !ending node
         return           
      end if
      nbin_max = 0
      do kvar = 1, num_var_for_node
         ivar = list_available(kvar)
         nbinj(ivar) = num_bin_temp_max
c nbinj starts the same for all variables.
         value = 1.e17
         imix = 0
         do kevt = 1,num_available
            ievt = list_available(kevt)
            index = sorted_index_train(ievt,ivar)
            if (list_train_for_tree(index) .eq.0) go to 398
            if (.not.((last_node .eq. no_node).or. 
     +          (last_node.eq.sorted_node).or.
     +           ((evt_last_node(index).eq.last_node)
     +          .and.(leftright_from_last(index)
     +          .eq. leftright_from_parent(inode))))) go to 398
            value_test = train_dat(index,ivar)
            if (value_test .ne. value) then
               imix = imix + 1
               value = value_test
               val_bin_evts(imix) = value
               if (index .le. num_train_sig) then
                  wgt_bin_evts_sig(imix) = weight2(index)
                  wgt_bin_evts_bkrd(imix) = 0.
               else
                  wgt_bin_evts_sig(imix) = 0.
                  wgt_bin_evts_bkrd(imix) = weight2(index)
               end if
            else
               if (index .le. num_train_sig) then   !signal event
                  wgt_bin_evts_sig(imix) = wgt_bin_evts_sig(imix) 
     +                                             + weight2(index)
               else                                 !background event
                  wgt_bin_evts_bkrd(imix) = wgt_bin_evts_bkrd(imix) 
     +                                               + weight2(index)
c  weight2 incorporates list_train_for_tree if it is >1
               end if
            end if
 398        continue
         end do   !ievt = 1, num_available
         nmix = imix
         nbinj(ivar) = min0(nmix,nbinj(ivar))
         nbin_max = max(nbin_max,nbinj(ivar))
         if (nbinj(ivar) .lt. nmix) then
            ihalf = (nmix - nbinj(ivar)*(nmix/nbinj(ivar)))/2
         else
            ihalf = 0
         end if
         num_per_bin = nmix/nbinj(ivar)
         do ibin = 1,nbinj(ivar)
            wgt_in_bin_sig(ibin,ivar) = 0.
            wgt_in_bin_bkrd(ibin,ivar) = 0.
         end do   !ibin = 1,nbinj(ivar)
         num_in_bin = -ihalf
         ibin = 1
         num_local = 0
c  bin boundaries are to be at lower edges of bin
c         bin_value(1,ivar) = val_bin_evts(1)
         do imix = 1, nmix
c            if ((ibin .ne. 1).and. (num_local .eq. 0))
            if (num_local .eq.0)
     +           bin_value(ibin,ivar) = val_bin_evts(imix)
            num_local = num_local + 1
            wgt_in_bin_sig(ibin,ivar) = wgt_in_bin_sig(ibin,ivar) 
     +                                + wgt_bin_evts_sig(imix)
            wgt_in_bin_bkrd(ibin,ivar) = wgt_in_bin_bkrd(ibin,ivar)
     +                                 + wgt_bin_evts_bkrd(imix) 
            if ((num_local .ge. num_per_bin).and.
     +          (ibin .lt. nbinj(ivar))) then
c  Here if at bin boundary
               ibin = ibin + 1
               num_local = 0
            end if
         end do   !imix = 1,nmix
         bin_value(nbinj(ivar)+1,ivar) = 1.e17
      end do   !kvar=1,num_var_for_node
      cut_crit_node(inode) = 1.e17
c      if (inode .ge.24) write(*,*) 'nbin_max ',nbin_max,'nbinj',
c     +        (nbinj(ivar),ivar=1,nvar)
      if (nbin_max .le. 1) then !declare this to be an ending node
         next_left_node(inode,itree) = sorted_node
         next_right_node(inode,itree) = sorted_node
         if (weight_sig_temp+weight_bkrd_temp .gt. 0.) then
            purity_left(inode,itree) = weight_sig_temp
     +                        /(weight_sig_temp+weight_bkrd_temp)
         else
            purity_left(inode,itree) = 0.
         end if
      end if
c      write(*,*) 'make_node--inode',inode
      do kvar=1,num_var_for_node
         ivar = list_var_for_node(kvar)
         if (nbinj(ivar).le. 1) go to 9
         weight_sig_temp = 0.
         weight_bkrd_temp = 0.
         do ibin = 1,nbinj(ivar)
            weight_sig_temp = weight_sig_temp +wgt_in_bin_sig(ibin,ivar)
            weight_bkrd_temp = weight_bkrd_temp 
     +                         + wgt_in_bin_bkrd(ibin,ivar)
         end do   !ibin
         weight_tot(inode) = weight_sig_temp+weight_bkrd_temp
         weight_left_leaf_sig = 0.
         weight_left_leaf_bkrd = 0.
         weight_right_leaf_sig = weight_sig_temp
         weight_right_leaf_bkrd = weight_bkrd_temp
         weight_temp = weight_right_leaf_sig +weight_right_leaf_bkrd
         temp_cut_crit = 1.e17
c  for each variable in turn try to find best place to cut
         do ibin = 1,nbinj(ivar)
c  value is to be lowest value of next bin
            value = bin_value(ibin+1,ivar)
            if (ibin.lt.nbinj(ivar)) then
               wgt_index_sig = wgt_in_bin_sig(ibin,ivar)
               wgt_index_bkrd = wgt_in_bin_bkrd(ibin,ivar)
               weight_left_leaf_sig = weight_left_leaf_sig +
     $              wgt_index_sig
               weight_left_leaf_bkrd = weight_left_leaf_bkrd 
     +                                                 + wgt_index_bkrd
               weight_right_leaf_sig = weight_right_leaf_sig 
     +                                                 - wgt_index_sig
               weight_right_leaf_bkrd = weight_right_leaf_bkrd 
     +                                                 - wgt_index_bkrd
               weight_left_leaf = weight_left_leaf_sig 
     +                                   + weight_left_leaf_bkrd 
               weight_right_leaf = weight_right_leaf_sig 
     +                                   + weight_right_leaf_bkrd 
               if (weight_left_leaf .gt. 0.) then
                  temp_purity_left = weight_left_leaf_sig
     $                 /weight_left_leaf
               else
                  temp_purity_left = 0.
               end if
               if (weight_right_leaf .gt. 0.) then
                  temp_purity_right = weight_right_leaf_sig
     +                 /weight_right_leaf
               else
                  temp_purity_right = 0.
               end if
               temp_cut_crit = (weight_left_leaf*temp_purity_left*
     +              (1. - temp_purity_left)
     +              + weight_right_leaf*temp_purity_right*
     +              (1. - temp_purity_right))
     +              /weight_tot(inode)
            else                !here for ibin = nbinj--protect vs roundoff
		      weight_right_leaf = 0.
		      weight_right_leaf_sig = 0.
		      weight_right_leaf_bkrd = 0.
		      weight_left_leaf = weight_temp
		      weight_left_leaf_sig =weight_sig_temp
		      weight_left_leaf_bkrd = weight_bkrd_temp
		      temp_purity_right = 0.
		      temp_purity_left = weight_sig_temp/weight_temp
		      temp_cut_crit = temp_purity_left*(1.-temp_purity_left)
            end if
c            if ((inode.eq.4).and.(itree.eq.3).and.(ivar.eq.10)
c     +           .and. (ibin.lt.20)) then
c               write(*,*)'ibin,cut_crit',ibin,temp_cut_crit
c               if (ibin==23) 
c              write(*,*)'wgtleft,pleft,sig,bk wgt left,'
c     +         ,'pright,sig,bk wgt right= ',
c     +            weight_left_leaf,temp_purity_left,
c     +           weight_left_leaf_sig,weight_left_leaf_bkrd,
c     +            weight_right_leaf,temp_purity_right,
c     +            weight_right_leaf_sig,weight_right_leaf_bkrd
c            end if
c  Want to minimize criterion (it is 0 for P=1 or P=0).
c     If less than or equal to cut--go to right and check to see if best
c     so far
            if (temp_cut_crit .lt. cut_crit_node(inode)) 
     +            then
c  Set this as best so far
               cut_crit_node(inode) = temp_cut_crit
               best_var = ivar
               best_value = value
c               if ((inode.ge.3).and.(itree.eq.3)) then
c                  write(*,*) 
c     +         'cut_crit,best var,val'
c     +         ,cut_crit_node(inode),best_var,best_value
c     +         ,"nbinj,ibin ",nbinj(ivar),ibin
c                  write(*,*) 'wgt temp sig,bkrd',
c     +                weight_sig_temp,weight_bkrd_temp
c               end if
c  This value or greater goes to right
               purity_right(inode,itree) = temp_purity_right
               purity_left(inode,itree) = temp_purity_left
               weight_left_leaf_sig_var = weight_left_leaf_sig
               weight_left_leaf_bkrd_var = weight_left_leaf_bkrd
               weight_left_leaf_var(inode) =  weight_left_leaf
               weight_right_leaf_var(inode) = weight_right_leaf
            end if   !cut_crit is best so far
         end do   !ibin=1,nbinj(ivar)
 9       continue
      end do      ! kvar = 1,num_var_for_node
c 
      return
      end
c-----------------------------------------------------------------------
      subroutine make_node2_evts(inode,itree)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer ivar,ievt,index,best_var,inode,itree,nsig,nbkrd
     +   ,last_node,kvar,kevt
      real value, weight_left_leaf_sig,weight_right_leaf_sig
     +     ,weight_left_leaf_bkrd,weight_right_leaf_bkrd
     +     ,temp_purity_left,temp_purity_right
     +     ,weight_bkrd_temp,weight_left_leaf_sig_var
     +     ,weight_left_leaf_bkrd_var,weight_left_leaf
     +     ,weight_right_leaf,best_value,weight_sig_temp
     +     ,wgt_index_sig,wgt_index_bkrd,temp_cut_crit
      real var_max(nvar),var_min(nvar)
      common/make_node_local/var_max,var_min,best_var,best_value
     +     ,weight_sig_temp,weight_bkrd_temp,nsig,nbkrd,last_node

      cut_crit_node(inode) = 1.e17
c      write(*,*) 'make_node--inode',inode
      do kvar=1,num_var_for_node
         ivar = list_var_for_node(kvar)
         weight_left_leaf_sig = 0.
         weight_left_leaf_bkrd = 0.
         weight_right_leaf_sig = weight_sig_temp
         weight_right_leaf_bkrd = weight_bkrd_temp
         value = 1.e17
c  for each variable in turn try to find best place to cut
c  I make my own loop here
         ievt = 0
 6          wgt_index_sig = 0.
            wgt_index_bkrd = 0.
 7          ievt = ievt + 1
            if (ievt .gt. num_train_tot) then
               if ((wgt_index_sig+wgt_index_bkrd).gt.0.) then
                  go to 8  !some more events to transfer at end
               else
                  go to 9  !none left
               end if
            end if
            index = sorted_index_train(ievt,ivar)
            if (list_train_for_tree(index) .eq.0) go to 7
            if (.not.((last_node .eq. no_node) .or.
     +         (last_node .eq. sorted_node) .or.
     +         ((evt_last_node(index).eq.last_node)
     +      .  and.(leftright_from_last(index).eq.
     +         leftright_from_parent(inode)))))  go to 7
c check if several events have same value
            if ((train_dat(index,ivar) .ne. value).and.
     +          ((wgt_index_sig + wgt_index_bkrd) .gt.0.)) then
               value = train_dat(index,ivar)
               ievt = ievt -1
               go to 8
            end if
            if (index .le. num_train_sig) then
               wgt_index_sig = wgt_index_sig + weight2(index)
            else
               wgt_index_bkrd = wgt_index_bkrd + weight2(index)
c  For choosing events with replacement, list can be > 1, and weight2
c  incorporates this.
            end if
            go to 7
 8          continue   !Now find the criterion
            weight_left_leaf_sig = weight_left_leaf_sig + wgt_index_sig
            weight_left_leaf_bkrd = weight_left_leaf_bkrd 
     +                                                 + wgt_index_bkrd
            weight_right_leaf_sig = weight_right_leaf_sig 
     +                                                 - wgt_index_sig
            weight_right_leaf_bkrd = weight_right_leaf_bkrd 
     +                                                 - wgt_index_bkrd
            weight_left_leaf = weight_left_leaf_sig 
     +                                   + weight_left_leaf_bkrd 
            if (weight_right_leaf_sig .le. 0.) weight_right_leaf_sig=0.
            weight_right_leaf = weight_right_leaf_sig 
     +                                   + weight_right_leaf_bkrd 
            if (weight_left_leaf .gt. 0.) then
               temp_purity_left = weight_left_leaf_sig/weight_left_leaf
            else
               temp_purity_left = 0.
               weight_left_leaf = 0.
            end if
            if (weight_right_leaf .gt. 0.) then
               temp_purity_right = weight_right_leaf_sig
     +                                               /weight_right_leaf
            else
               temp_purity_right = 0.
               weight_right_leaf = 0.
            end if
            temp_cut_crit = (weight_left_leaf*temp_purity_left*
     +                                       (1. - temp_purity_left)
     +                    + weight_right_leaf*temp_purity_right*
     +                                       (1. - temp_purity_right))
     +                    /weight_tot(inode)
c  Want to minimize criterion (it is 0 for P=1 or P=0).
c     If less than or equal to cut--go to right and check to see if best
c     so far
            if (temp_cut_crit .lt. cut_crit_node(inode)) 
     +            then
c  Set this as best so far
               cut_crit_node(inode) = temp_cut_crit
               best_var = ivar
               best_value = value
c  This value or greater goes to left
               purity_right(inode,itree) = temp_purity_right
               purity_left(inode,itree) = temp_purity_left
               weight_left_leaf_sig_var = weight_left_leaf_sig
               weight_left_leaf_bkrd_var = weight_left_leaf_bkrd
               weight_left_leaf_var(inode) =  weight_left_leaf
               weight_right_leaf_var(inode) = weight_right_leaf
            end if   !cut_crit is best so far
         if (ievt .lt. num_train_tot) go to 6  !end of loop over ievt
 9       continue
      end do      ! kvar = 1,num_var_for_node
      return
      end
c-----------------------------------------------------------------------
      subroutine update_weights(itree)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer itree,ievt
     +   ,next_node,itry,wrong_num
      real test,purity
      real weight_wrong,err_m,weight_tot_temp
      real max_wgt,min_wgt,dum,myran_sing
      integer wrong_sig,wrong_bkrd,wrong_tot
      real wrong_wt_sig, wrong_wt_bkrd
c
c  Set wrong_class to 1 for events wrongly classified
c  Events <=num_train_sig are signal, after are background
c  Go through all nodes with next_nodes vacant
      call vzero(wrong_class,num_train_tot)
      wrong_sig = 0
      wrong_bkrd = 0
      wrong_tot = 0
      wrong_wt_sig = 0.
      wrong_wt_bkrd = 0.
      weight_tot_temp = 0.
      do ievt = 1,num_train_tot
         next_node = 1
         weight_tot_temp = weight_tot_temp + weight(ievt)
 5       continue
c         if ((next_node.eq.1).and.(ievt.eq.1)) then
c            write(*,*) 'itree,num_available_sig,num_available_bkrd',
c     +    itree,num_available_sig,num_available_bkrd 
c            write(*,*) 'node_var',node_var(next_node,itree)
c         end if
         if (train_dat(ievt,node_var(next_node,itree)) .lt.
     +                node_val(next_node,itree)) then
c  Go to left node
            purity = purity_left(next_node,itree)
            next_node = next_left_node(next_node,itree)
         else
c  Go to right node
            purity = purity_right(next_node,itree)
            next_node = next_right_node(next_node,itree)
         end if   !pick next node
         if ((next_left_node(next_node,itree).ne. no_node) .and.
     +             (next_left_node(next_node,itree).ne. sorted_node))
     +              go to 5
c  Here if at ending node
         if ((purity .ge. purity_cut) .and. 
     +             (ievt. gt. num_train_sig)) then
            wrong_class(ievt) = 1
            wrong_bkrd = wrong_bkrd +1
            wrong_wt_bkrd = wrong_wt_bkrd + weight(ievt)
         end if
         if ((purity .lt. purity_cut) .and.
     +              (ievt. le. num_train_sig)) then
            wrong_class(ievt) = 1
            wrong_sig = wrong_sig + 1
            wrong_wt_sig = wrong_wt_sig + weight(ievt)
         end if
      end do               !ievt = 1,num_train_tot
      if (.not.weight_wrong_evts) then
         alpha_m(itree)=1
         return
      end if
      if (ada_or_epsilon .eq. eps) then !Here for epsilon boosting
         weight_tot_temp = 0.
         do ievt = 1, num_train_tot
c            if (myran_sing(dum) .gt. .2)
c     +        weight(ievt)=weight(ievt)
c     +                  *exp(2.*epsilon*wrong_class(ievt))
             weight(ievt)=weight(ievt)
     +                   *exp(2.*epsilon*wrong_class(ievt))

             weight_tot_temp = weight_tot_temp + weight(ievt)
         end do   !ievt = 1, num_train_tot 
      else   !Here for ada boosting
         weight_wrong = wrong_wt_bkrd+wrong_wt_sig
         wrong_num = wrong_bkrd+wrong_sig
         err_m = (weight_wrong/weight_tot_temp)
         if (err_m .gt. 0.) then
 456        alpha_m(itree) = alog((1. - err_m)/err_m)*alpha_const
            alpha_m(itree) = amax1(alpha_m(itree),epsilon)
c            write(*,*) 'itree,err_m,alpha_m,',itree,err_m,alpha_m(itree)
c            write(*,*)
c     $        'wrong_sig,bkrd,tot, wrongwtsig,bkre,tot,wrong_num',
c     +        'weight_wrong',wrong_sig,wrong_bkrd,wrong_sig+wrong_bkrd
c     +        ,wrong_wt_sig,wrong_wt_bkrd,wrong_wt_sig+wrong_wt_bkrd
c     +        ,wrong_num,weight_wrong
         else
            write(*,*) 'Oops, err_m = 0 for itree= ',itree
            alpha_m(itree) = 0.
            call check_purity(itree)
            stop
         end if
c         write(*,*)'itree,err_m,alpha_m',itree,err_m,alpha_m(itree)
         weight_tot_temp = 0.
         do ievt = 1, num_train_tot
c            if ((alpha_m(itree).gt.epsilon).or.(myran_sing(dum).gt..2))
c            if (myran_sing(dum).gt..2)
             weight(ievt) = weight(ievt)*exp(alpha_m(itree)
     +                                      *wrong_class(ievt))
            weight_tot_temp = weight_tot_temp + weight(ievt)
         end do   !ievt = 1, num_train_tot         
      end if  !epsilon or ada
c  Renormalize weights for events used in this tree
      itry = 0
      test = trim_wgt/float(num_train_tot)
 75   num_available_sig = 0
      num_available_bkrd = 0
      num_available = 0
      max_wgt = 0.
      min_wgt = 1.e17
      do ievt = 1,num_train_tot
         weight(ievt) = weight(ievt)/weight_tot_temp
         max_wgt = amax1(max_wgt,weight(ievt))
         min_wgt = amin1(min_wgt,weight(ievt))
      end do   !ievt = 1,num_train_tot
      if (test .ge. max_wgt) then
         write(*,*)'itree,max_wgt,min_wgt,test'
     +               ,itree,max_wgt,min_wgt,test
         test = (max_wgt + min_wgt)/2.
      end if
      do ievt = 1,num_train_tot      
         if (weight(ievt) .ge. test) then
            num_available = num_available + 1
            list_available(num_available) = ievt
            if (ievt .le. num_train_sig) then
               num_available_sig = num_available_sig + 1
            else
               num_available_bkrd = num_available_bkrd + 1
            end if
         end if
      end do   !ievt = 1,num_train_tot
      if ((num_available_sig.lt.(min_node_size+1)).or.
     +          (num_available_bkrd.lt.(min_node_size+1))) then
         itry = itry + 1
         test = test/2.
         if (itry .lt. 10) go to 75
         done= .true.
         call check_purity(itree)
         stop
      end if
c      write(*,*) 'itree,test,wgt_min,wgt_max',itree,test,min_wgt,max_wgt
c      write(*,*)'itree,trim,test,num_train_sig,num_available_sig,',
c     +   'num_train_bkrd,num_available_bkrd',
c     +   itree,trim_wgt,test,num_train_sig,num_available_sig,
c     +   num_train_bkrd,num_available_bkrd

      return
      end

c-----------------------------------------------------------------------
      subroutine check_purity(itree)
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
c  Here we will try to check the purity for about 50% signal efficiency.
      real sum_T_m,test,num_kept_sig(9),num_kept_bkrd(9)
     +     ,sum_T_m_sig(nevt_max),sum_T_m_bkrd(nevt_max),purity
     +     ,frac_kept_sig(9),frac_kept_bkrd(9)
      integer ievt,ktree,next_node,itree_last,itree,min_tree
      integer next_right_node_save(max_nodes,max_num_trees)
     +   , next_left_node_save(max_nodes,max_num_trees)
     +   ,node_var_save(max_nodes,max_num_trees),itr,inode
     +   ,sorted_list_t_m_sig(nevt_max),sorted_list_t_m_bkrd(nevt_max)
     +   ,icut,icut2
      real node_val_save(max_nodes,max_num_trees)
     +   ,alpha_m_save(max_num_trees)
     +   ,purity_right_save(max_nodes,max_num_trees)
     +   ,purity_left_save(max_nodes,max_num_trees)
     +   ,sum_T_m_save,cut_point(9),btemp,tempT
      save itree_last
      real min_ratio
      include 'boost_files.inc'
      data itree_last/0/
      data min_ratio/100./
      data btemp/0.5/
      if (itree_last .eq. 0) then
c  Initialize the T_m's
         do ievt = 1,num_sig-num_train_sig
            sum_T_m_sig(ievt) = 0.
         end do   !ievt = 1,num_sig-num_train_sig
         do ievt = 1,num_bkrd-num_train_bkrd
            sum_T_m_bkrd(ievt) = 0.
         end do   !ievt = 1,num_bkrd-num_train_bkrd
      end if   !Initialize T_m's
      do ievt = 1,num_sig-num_train_sig
         do ktree = itree_last+1,itree
            next_node = 1
 5          continue
            if (test_dat_sig(ievt,node_var(next_node,ktree)) .lt.
     +                             node_val(next_node,ktree)) then
c  go to left node
               purity = purity_left(next_node,ktree)
               next_node = next_left_node(next_node,ktree)
            else
c  go to right node
               purity = purity_right(next_node,ktree)
               next_node = next_right_node(next_node,ktree)
            end if   !pick next node
            if( (next_left_node(next_node,ktree) .ne. no_node).and.
     +          (next_left_node(next_node,ktree) .ne. sorted_node)) 
     +          go to 5
c  here if at an ending node
 10         if (ada_or_epsilon .eq. eps) then !epsilon boost
               tempT = epsilon
            else
               tempT = alpha_m(ktree)
            end if
            if  (purity .lt. purity_cut) tempT = -tempT
            if (weight_wrong_evts.and.soft_score)
     +          tempT = tempT*(abs(2.*purity-1.))**btemp
            sum_T_m_sig(ievt) = sum_T_m_sig(ievt) + tempT
         end do   !ktree = itree_last+1,itree
      end do   !ievt = 1,num_sig-num_train_sig
      do ievt = 1,num_bkrd-num_train_bkrd
         do ktree = itree_last+1,itree
            next_node = 1
 15         if (test_dat_bkrd(ievt,node_var(next_node,ktree))
     $           .lt. node_val(next_node,ktree)) then
c  go to left node
               purity = purity_left(next_node,ktree)
               next_node = next_left_node(next_node,ktree)
            else
c  go to right node
               purity = purity_right(next_node,ktree)
               next_node = next_right_node(next_node,ktree)
            end if   !pick next node
            if( (next_left_node(next_node,ktree) .ne. no_node).and.
     +          (next_left_node(next_node,ktree) .ne. sorted_node)) 
     +          go to 15
c  here if at an ending node
 20         if (ada_or_epsilon .eq. eps) then !epsilon boost
               tempT = epsilon
            else
               tempT = alpha_m(ktree)
            end if
            if  (purity .lt. purity_cut) tempT = -tempT
            if (weight_wrong_evts.and.soft_score)
     +          tempT = tempT*(abs(2.*purity-1.))**btemp
            sum_T_m_bkrd(ievt) = sum_T_m_bkrd(ievt) + tempT
         end do   !ktree = itree_last+1,itree
      end do   !ievt = 1,num_bkrd-num_train_bkrd
      itree_last = itree
      call sortzv(sum_T_m_sig,sorted_list_T_m_sig,num_sig-num_train_sig
     +   ,1,0,0)
      call sortzv(sum_T_m_bkrd,sorted_list_T_m_bkrd,num_bkrd
     +   -num_train_bkrd,1,0,0)
c  Now the T_m values are sorted.  Find the signal cut points to keep
c  10,20,30,...90 percent of signal
      do icut = 1,9
         test = float((10-icut)*(num_sig-num_train_sig))/10.
         num_kept_sig(icut) = float(num_sig-num_train_sig) - test
         cut_point(icut) = sum_T_m_sig(sorted_list_T_m_sig(ifix(test)))
c         write(*,*) 'icut,cut_point(icut)',
c     +      'num_kept_sig(icut)',icut,cut_point(icut),num_kept_sig(icut)
      end do   !icut = 1,9
      sum_T_m = cut_point(5)
      icut = 9
c  Now find out fractions of background kept for the different signal
c  fractions.
c      write(*,*) 'bkrd-first,last',sum_T_m_bkrd(sorted_list_T_m_bkrd
c     + (1)),sum_T_m_bkrd(sorted_list_T_m_bkrd(num_bkrd-num_train_bkrd)) 
      do ievt = 1,num_bkrd-num_train_bkrd
         if (sum_T_m_bkrd(sorted_list_T_m_bkrd(ievt)) .ge. 
     +               cut_point(icut)) then
            num_kept_bkrd(icut) = float(num_bkrd-num_train_bkrd-ievt+1)
c            write(*,*) 'icut,numbkd',icut, num_kept_bkrd(icut) 
            icut = icut - 1
            if (icut .lt. 1) go to 25
         end if
      end do   !ievt = 1,num_train-num_train_bkrd
c  Protect against having all background kept before icut=9
      do icut2 = icut,1,-1
         num_kept_bkrd(icut2) = 0.
c            write(*,*) 'icut,numbkd',icut, num_kept_bkrd(icut) 
      end do   !icut2 = icut,9
 25   continue
c  Histogram some quantities for passed bkrd evts for icut=5
c      do ievt = 1,num_bkrd-num_train_bkrd
c         if ((itree.eq.176).and.(sum_T_m_bkrd(ievt) .ge. cut_point(5))) 
c     +       then
c            call hfill(540,test_dat_bkrd(ievt,50),0.,1.)
c            call hfill(541,test_dat_bkrd(ievt,52),0.,1.)
c            call hfill(542,test_dat_bkrd(ievt,51),0.,1.)
c         end if
c      end do   !ievt = 1,num_train-num_train_bkrd
      do icut = 1,9
c         write(*,*) 'icut,fracsig,denom,fracbkd,denom,nbk,ntrbk',icut
c     +     , num_kept_sig(icut),float(num_sig-num_train_sig)
c     +     , num_kept_bkrd(icut),float(num_bkrd-num_train_bkrd)
c     +     , num_bkrd,num_train_bkrd
         frac_kept_sig(icut) = num_kept_sig(icut)
     +                    /float(num_sig-num_train_sig)
         frac_kept_bkrd(icut) = num_kept_bkrd(icut)
     +                   /float(num_bkrd-num_train_bkrd)
         if (frac_kept_sig(icut) .gt. 0.) then
            ratio(icut) = frac_kept_bkrd(icut)/frac_kept_sig(icut)
         else
            ratio(icut) = 10.
         end if
      end do   ! icut = 1,9
      write(*,*) 'itree,frac_kept_sig,frac_kept_bkrd,ratio,',
     +         'num_kept_bkd,num_kept_sig,'
      write(*,*) 'score= ',
     +         itree,frac_kept_sig(5),frac_kept_bkrd(5),ratio(5)
     +         ,num_kept_bkrd(5),num_kept_sig(5),cut_point(5)
c      write(*,*) 'avail--sig,bk',num_available_sig,num_available_bkrd
      if (ratio(5) .lt. min_ratio) then
         min_ratio = ratio(5)
         min_tree = itree
c  save the tree variables and cut points to make a file at the end
         do itr = 1,min_tree
            alpha_m_save(itr) = alpha_m(itr)
            do inode = 1,max_nodes
               next_right_node_save(inode,itr) = 
     +                 next_right_node(inode,itr)
               next_left_node_save(inode,itr) = 
     +                 next_left_node(inode,itr)
               node_var_save(inode,itr) =node_var(inode,itr)
               node_val_save(inode,itr) =node_val(inode,itr)
               purity_right_save(inode,itr) =
     +              purity_right(inode,itr)   
               purity_left_save(inode,itr) =
     +              purity_left(inode,itr)   
            end do   !inode = 1,max_nodes
         end do      !itr = 1,min_tree
         sum_T_m_save = sum_T_m
      end if
 50   continue
      if ((itree .ge. max_num_trees).or.(done)) then
         write(*,*) 
     +         'The minimum ratio ',min_ratio,' was achieved for tree ',
     +        min_tree,' score = ',sum_T_m_save
         write(40,*) 
     +         'The minimum ratio ',min_ratio,' was achieved for tree ',
     +           min_tree,' score = ',sum_T_m_save
c  Write out the best tree information
         if (num_file_tree .gt. 0) then
            open(50,file=file_tree(1),form='FORMATTED'
     +           ,status='unknown')
            write(50,8800) min_ratio,min_tree
     +           ,num_sig,num_bkrd,num_train_sig,num_train_bkrd
     $           ,max_nodes,sum_T_m_save,epsilon,alpha_const,purity_cut
     $           ,ada_or_epsilon
            write(50,8801) (alpha_m_save(itr),itr=1,min_tree)
            do itr = 1,min_tree
               do inode = 1,max_nodes
                  write(50,8802)
     +                 purity_right_save(inode,itr)
     +                 ,purity_left_save(inode,itr)
     +                 ,next_right_node_save(inode,itr)
     +                 ,next_left_node_save(inode,itr)
     +                 ,node_var_save(inode,itr)
     +                 ,node_val_save(inode,itr)
               end do           !inode = 1,node
            end do              !itr = 1,min_tree
 8800       format((1x,f10.2),6(1x,i10),4(1x,f10.5),1x,i5)
 8801       format(10(1x,E12.5))
 8802       format(2(1x,E12.5),3(1x,I12),(1x,E12.5))
         end if !if there is a tree out file
      end if  !if at max number trees
 60   continue
c      write(*,*) 'sum_T_m_min,sum_T_m_max', sum_T_m_min,sum_T_m_max
c      write(*,*) 'test,num_sig-num_train_sig'
c     +      ,test,num_sig-num_train_sig
c      write(*,*) 'itree_last',itree_last
      call output_var(1,float(num_train_sig))
      call output_var(2,float(num_train_bkrd))
      call output_var(3,float(itree))
      do ievt = 1,num_sig-num_train_sig
         call hfill(201,sum_T_m_sig(ievt),0.,1.)
      end do
      do ievt = 1,num_bkrd-num_train_bkrd
         call hfill(202,sum_T_m_bkrd(ievt),9.,1.)
      end do
      do icut = 1,9
         call hfill(500+icut,float(itree),frac_kept_sig(icut),1.)
         call hfill(510+icut,float(itree),frac_kept_bkrd(icut),1.)
         call hfill(520+icut,float(itree),ratio(icut),1.)
         call hfill(530+icut,float(itree),ratio(icut),1.)
         call output_var(3+icut,num_kept_sig(icut))
         call output_var(12+icut,num_kept_bkrd(icut))
         call output_var(21+icut,cut_point(icut))
         call output_var(30+icut,frac_kept_sig(icut))
         call output_var(39+icut,frac_kept_bkrd(icut))
         call output_var(48+icut,ratio(icut))
      end do   !icut = 1,9

      call output_var(-1,0.)
      return
      end

c-----------------------------------------------------------------------
      subroutine data_loop_over_trees
      implicit none
      include 'boost_param.inc'
      include 'boost_com.inc'
      integer itree,itr,ifile,inode,ievt,ktree,ivar,tempscore,isum,i
      real purity,min_ratio,sum_T_m_save
      integer min_tree,num_sig_save,num_bkrd_save,num_train_sig_save
     +    ,ada_or_epsilon_save
     +    ,num_train_bkrd_save,max_nodes_save,next_node
      real min_ratio_save,epsilon_save,alpha_const_save,purity_cut_save
     +    ,alpha_m_save(max_num_trees)
      include 'boost_files.inc'
      write(*,*)'At data loop starting to read in tree files'
      if (num_file_tree .le.0) then
         write(*,*) 'No tree files to read in'
         stop
      end if
      write(*,*)'num_file_tree,file = ',num_file_tree," ",file_tree(1)
      do ifile = num_file_tree_old+1,(num_file_tree_old+num_file_tree)
         open(70+ifile,file = file_tree(ifile-num_file_tree_old)
     +           ,form = 'FORMATTED',status='OLD')
            read(70+ifile,8800) min_ratio,min_tree
     +           ,num_sig_save,num_bkrd_save,num_train_sig_save 
     +           ,num_train_bkrd_save
     $           ,max_nodes_save,sum_T_m_save,epsilon_save
     +           ,alpha_const_save,purity_cut_save
     $           ,ada_or_epsilon_save
            read(70+ifile,8801) (alpha_m_save(itr),itr=1,min_tree)
            do itr = 1,min_tree
               do inode = 1,max_nodes_save
                  read(70+ifile,8802)
     +                 purity_right(inode,itr)
     +                 ,purity_left(inode,itr)
     +                 ,next_right_node(inode,itr)
     +                 ,next_left_node(inode,itr)
     +                 ,node_var(inode,itr)
     +                 ,node_val(inode,itr)
               end do           !inode = 1,node
            end do              !itr = 1,min_tree
 8800       format((1x,f10.2),6(1x,i10),4(1x,f10.5),1x,i5)
 8801       format(10(1x,E12.5))
 8802       format(2(1x,E12.5),3(1x,I12),(1x,E12.5))
            tempscore = 0;
            write(*,*)'min_tree ',min_tree
            do ievt=1,num_data
c             write(*,*)'I am at event ',ievt,' num_data ',num_data
               sum_T_m_dat(ifile,ievt)=0.
               do itree=1,min_tree ! might want for all trees not just to min
c              write(*,*) 'I am calling get purity itree, ievt ',itree
c     +       ,ievt

                  next_node = 1
 5                continue
                  if (event_dat(ievt,node_var(next_node,itree)) .lt.
     +                 node_val(next_node,itree)) then
c     Go to left node
                     purity = purity_left(next_node,itree)
                     next_node = next_left_node(next_node,itree)
                  else
c     Go to right node
                     purity = purity_right(next_node,itree)
                     next_node = next_right_node(next_node,itree)
                  end if        !pick next node
                  if ((next_left_node(next_node,itree).ne. no_node) .and
     $                 .(next_left_node(next_node,itree).ne. sorted_node
     $                 ))go to 5
c     if ((itree.eq.4).and.(ievt.eq.6)) write(*,*)'purity '
c     ,purity
c     This routine finds the purity at the ending node for this event
c     write(*,*)'I am past get purity'
                  if (purity.ge. purity_cut_save) then
                     if (ada_or_epsilon_save.eq.eps) then !epsilon boost
                        sum_T_m_dat(ifile,ievt)= sum_T_m_dat(ifile
     $                       ,ievt)+  epsilon_save
                     else       !ada boost      
                        sum_T_m_dat(ifile,ievt) =sum_T_m_dat(ifile
     $                       ,ievt)+ alpha_m_save(itree)
c     if (ievt.eq.6)
c     write(*,*) 'sum at Ada ',sum_T_m_dat(ifile,ievt)
                     end if     !ada or epsilon
                  else  !purity less than purity_cut
                     if (ada_or_epsilon_save.eq.eps) then !   epsilon boost
                        sum_T_m_dat(ifile,ievt) = sum_T_m_dat(ifile
     $                       ,ievt)-epsilon_save
                     else
                        sum_T_m_dat(ifile,ievt) = sum_T_m_dat(ifile
     $                       ,ievt)-alpha_m_save(itree)
c     if (ievt.eq.7)
c     write(*,*)'ievt ',ievt,'sum_T ',sum_T_m_dat(ifile,ievt)
c     ,'purity ',purity
c     ,'itree ',itree,' alpha '
c     ,alpha_m_save(itree) 
                     end if     !ada_or_epsilon
                  end if        !Is purity greater than purity cut
               end do           !end of loop over trees
c               write(*,*) 'ievt = ',ievt
               if (sum_T_m_dat(ifile,ievt) .ge. sum_T_m_save) 
     +              tempscore = tempscore + 1
            end do              !end of loop over events
c       write(*,*)'I am at the end of the loop over events '
c      write(*,*)' numfile old,new ',num_file_tree_old,num_file_tree
c      write(*,*)'sum_T_m(0,5) ',sum_T_m_dat(0,5),' ifile = '
c     +           ,ifile
         end do                 !end of loop over tree files
c      write(*,*)' I am at the end of the loop over tree files;  
c      write(*,*)' write(*,*) 'itree,alpha'
c     +     (itree,alpha_m_save[itree],itree=1,11)
       write(*,*) ' tempscore ',tempscore,' num_data ',num_data,
     +  'sum_T_m_save ',sum_T_m_save
c  Next write out the new file if num_file_data_out is not 0
       if (num_file_data_out .le. 0) then
          write(*,*) 'Error: No file_data_out'
          return
       end if
       write(*,*)'The data out file is ',file_data_out(1)
c      There is a file for writing data.  Allow only 1 file and read it.
       open(15,file=file_data_out(1),form='FORMATTED',status='UNKNOWN')
c      
       write(15,*) num_data,(num_file_tree_old+num_file_tree),nvar_in
       write(*,*) 'num_data = ',num_data
       do ievt=1,num_data
	  if (nprefix.gt.0)  write(15,*) (prefix(i,ievt),i=1,nprefix)
          write(15,*)(sum_T_m_dat(isum,ievt),isum=1,num_file_tree_old
     $            +num_file_tree) 
          write(15,*) (event_dat(ievt,ivar),ivar=1,nvar_in)
       end do  !loop over events 
c      end of writing data_out
      return
      end
c-----------------------------------------------------------------------
      subroutine do_boost_hbook(iflag)
      implicit none
      integer ipaw,istat,icyc
      parameter (ipaw=35000000)
c      parameter (ipaw=1000000)
      real H(ipaw)
      common/pawc/H
      integer iflag
      include 'boost_files.inc'
      if (iflag .ne. 1) go to 10
c  Initialize hbook
      call hlimit(ipaw)
      if (num_file_results_out .gt. 0) then
C     RZ file for histograms is unit 4
         call hropen(4,'outh',
     +     file_results_out(1),'N',1024,istat)
         if (istat .ne. 0) then
            print 3602, istat
 3602       format(' Error in HROPEN:  istat= ',I13,'.')
            stop
         end if
      else    !no results file
         write(*,*) 'Error--no results_out file (PAW file) specified'
         stop
      end if
      call hcdir('//outh',' ')
      call hcdir('//PAWC',' ')
      call hermes(6)
      call houtpu(6)
C   initialize histograms
      call hbook2(501,'.1 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(502,'.2 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(503,'.3 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(504,'.4 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(505,'.5 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(506,'.6 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(507,'.7 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(508,'.8 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(509,'.9 fraction sig vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(511,'.1 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(512,'.2 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(513,'.3 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(514,'.4 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(515,'.5 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(516,'.6 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(517,'.7 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(518,'.8 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(519,'.9 fraction bkrd vs tree no',50,0.,2000.,50,0.
     +                ,1.,0.)
      call hbook2(521,'.1 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.1,0.)
      call hbook2(522,'.2 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.1,0.)
      call hbook2(523,'.3 double ratio vs tree no',50,0.,2000.,50,0.
     +                , .1,0.)
      call hbook2(524,'.4 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.1,0.)
      call hbook2(525,'.5 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.1,0.)
      call hbook2(526,'.6 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.1,0.)
      call hbook2(527,'.7 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.2,0.)
      call hbook2(528,'.8 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.2,0.)
      call hbook2(529,'.9 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.2,0.)
      call hbook2(531,'.1 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(532,'.2 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(533,'.3 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(534,'.4 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(535,'.5 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(536,'.6 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(537,'.7 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.02,0.)
      call hbook2(538,'.8 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.04,0.)
      call hbook2(539,'.9 double ratio vs tree no',50,0.,2000.,50,0.
     +                ,.1,0.)
c      call hbook1(540,'energy passed bkrd at 151',50,0.,2.,0.)
c      call hbook1(541,'rtc passed bkrd at 151',50,0.,500.,0.)
c      call hbook1(542,'rtowall passed bkrd at 151',50,0.,1200.,0.)
      call hbook1(1, 'var1--sig',50,-3.,3.,0.)
      call hbook1(2, 'var2--sig',50,-3.,3.,0.)
      call hbook1(3, 'var3--sig',50,-3.,3.,0.)
      call hbook1(4, 'var4--sig',50,-3.,3.,0.)
      call hbook1(5, 'var5--sig',50,0.,2.,0.)
      call hbook1(6, 'var6--sig',50,-3.,3.,0.)
      call hbook1(7, 'var7--sig',50,-3.,3.,0.)
      call hbook1(8, 'var8--sig',50,-3.,3.,0.)
      call hbook1(9, 'var9--sig',50,-3.,3.,0.)
      call hbook1(10,' var10--sig',50,-3.,3.,0.)
      call hbook1(11,' var11--sig',50,0.,10.,0.)
      call hbook1(12,' var12--sig',50,0.,5.,0.)
      call hbook1(13,' var13--sig',50,-3.,3.,0.)
      call hbook1(14,' var14--sig',50,-10.,10.,0.)
      call hbook1(15,' var15--sig',50,-3.,3.,0.)
      call hbook1(16,' var16--sig',50,-1.,5.,0.)
      call hbook1(17,' var17--sig',50,0.,5.,0.)
      call hbook1(18,' var18--sig',50,-5.,5.,0.)
      call hbook1(19,' var19--sig',50,0.,1.,0.)
      call hbook1(20,' var20--sig',50,0.,10.,0.)
      call hbook1(21,' var21--sig',50,-3.,3.,0.)
      call hbook1(22,' var22--sig',50,-3.,3.,0.)
      call hbook1(23,' var23--sig',50,-3.,3.,0.)
      call hbook1(24,' var24--sig',50,-3.,3.,0.)
      call hbook1(25,' var25--sig',50,-3.,3.,0.)
      call hbook1(26,' var26--sig',50,-3.,3.,0.)
      call hbook1(27,' var27--sig',50,-3.,3.,0.)
      call hbook1(28,' var28--sig',50,-3.,3.,0.)
      call hbook1(29,' var29--sig',50,.5,2.,0.)
      call hbook1(30,' var30--sig',50,-10.,10.,0.)
      call hbook1(31,' var31--sig',50,-3.,3.,0.)
      call hbook1(32,' var32--sig',50,-3.,3.,0.)
      call hbook1(33,' var33--sig',50,0.,4.,0.)
      call hbook1(34,' var34--sig',50,-3.,3.,0.)
      call hbook1(35,' var35--sig',50,-3.,3.,0.)
      call hbook1(36,' var36--sig',50,-80.,80.,0.)
      call hbook1(37,' var37--sig',50,-3.,3.,0.)
      call hbook1(38,' var38--sig',50,-3.,3.,0.)
      call hbook1(39,' var39--sig',50,-3.,3.,0.)
      call hbook1(40,' var40--sig',50,0.,30.,0.)
      call hbook1(41,' var41--sig',50,-3.,3.,0.)
      call hbook1(42,' var42--sig',50,-3.,3.,0.)
      call hbook1(43,' var43--sig',50,0.,8.,0.)
      call hbook1(44,' var44--sig',50,0.,6.,0.)
      call hbook1(45,' var45--sig',50,0.,250.,0.)
      call hbook1(46,' var46--sig',50,-3.,3.,0.)
      call hbook1(47,' var47--sig',50,-3.,3.,0.)
      call hbook1(48,' var48--sig',50,-3.,3.,0.)
      call hbook1(49,' var49--sig',50,-3.,3.,0.)
      call hbook1(50,' var50--sig',50,0.,4.,0.)
      call hbook1(51,' var51--sig',50,0.,550.,0.)
      call hbook1(52,' var52--sig',50,0.,1100.,0.)
      call hbook1(53,' var53--sig',50,0.,300.,0.)
      call hbook1(54,' var54--sig',50,0.,300.,0.)
      call hbook1(55,' var55--sig',50,-1.,1.,0.)
      call hbook1(56,' var56--sig',50,0.,1.05,0.)
      call hbook1(57,' var57--sig',50,0.,1.05,0.)
      call hbook1(58,' var58--sig',50,0.,25.,0.)
      call hbook1(59,' var59--sig',50,0.,12.,0.)
      call hbook1(60,' var60--sig',50,0.,100.,0.)
      call hbook1(61,' var51--sig',50,0.,12.,0.)
      call hbook1(62,' var62--sig',50,0.,50.,0.)
      call hbook1(63,' var63--sig',50,0.,10000.,0.)
      call hbook1(64,' var64--sig',50,0.,10000.,0.)
      call hbook1(65,' var65--sig',50,0.,.2,0.)
      call hbook1(66,' var66--sig',50,0.,.2,0.)
      call hbook1(67,' var67--sig',50,0.,12.,0.)
      call hbook1(68,' var68--sig',50,0.,12.,0.)
      call hbook1(69,' var69--sig',50,0.,20.,0.)
      call hbook1(70,' var70--sig',50,0.,50.,0.)
      call hbook1(71,' var71--sig',50,0.,50.,0.)
      call hbook1(101,' var1--bkrd',50,-3.,3.,0.)
      call hbook1(102,' var2--bkrd',50,-3.,3.,0.)
      call hbook1(103,' var3--bkrd',50,-3.,3.,0.)
      call hbook1(104,' var4--bkrd',50,-3.,3.,0.)
      call hbook1(105,' var5--bkrd',50,0.,2.,0.)
      call hbook1(106,' var6--bkrd',50,-3.,3.,0.)
      call hbook1(107,' var7--bkrd',50,-3.,3.,0.)
      call hbook1(108,' var8--bkrd',50,-3.,3.,0.)
      call hbook1(109,' var9--bkrd',50,-3.,3.,0.)
      call hbook1(110,' var10--bkrd',50,-3.,3.,0.)
      call hbook1(111,' var11--bkrd',50,0.,10.,0.)
      call hbook1(112,' var12--bkrd',50,0.,5.,0.)
      call hbook1(113,' var13--bkrd',50,-3.,3.,0.)
      call hbook1(114,' var14--bkrd',50,-10.,10.,0.)
      call hbook1(115,' var15--bkrd',50,-3.,3.,0.)
      call hbook1(116,' var16--bkrd',50,-1.,5.,0.)
      call hbook1(117,' var17--bkrd',50,0.,5.,0.)
      call hbook1(118,' var18--bkrd',50,-5.,5.,0.)
      call hbook1(119,' var19--bkrd',50,0.,1.,0.)
      call hbook1(120,' var20--bkrd',50,0.,10.,0.)
      call hbook1(121,' var21--bkrd',50,-3.,3.,0.)
      call hbook1(122,' var22--bkrd',50,-3.,3.,0.)
      call hbook1(123,' var23--bkrd',50,-3.,3.,0.)
      call hbook1(124,' var24--bkrd',50,-3.,3.,0.)
      call hbook1(125,' var25--bkrd',50,-3.,3.,0.)
      call hbook1(126,' var26--bkrd',50,-3.,3.,0.)
      call hbook1(127,' var27--bkrd',50,-3.,3.,0.)
      call hbook1(128,' var28--bkrd',50,-3.,3.,0.)
      call hbook1(129,' var29--bkrd',50,.5,2.,0.)
      call hbook1(130,' var30--bkrd',50,-10.,10.,0.)
      call hbook1(131,' var31--bkrd',50,-3.,3.,0.)
      call hbook1(132,' var32--bkrd',50,-3.,3.,0.)
      call hbook1(133,' var33--bkrd',50,0.,4.,0.)
      call hbook1(134,' var34--bkrd',50,-3.,3.,0.)
      call hbook1(135,' var35--bkrd',50,-3.,3.,0.)
      call hbook1(136,' var36--bkrd',50,-80.,80.,0.)
      call hbook1(137,' var37--bkrd',50,-3.,3.,0.)
      call hbook1(138,' var38--bkrd',50,-3.,3.,0.)
      call hbook1(139,' var39--bkrd',50,-3.,3.,0.)
      call hbook1(140,' var40--bkrd',50,0.,30.,0.)
      call hbook1(141,' var41--bkrd',50,-3.,3.,0.)
      call hbook1(142,' var42--bkrd',50,-3.,3.,0.)
      call hbook1(143,' var43--bkrd',50,0.,8.,0.)
      call hbook1(144,' var44--bkrd',50,0.,6.,0.)
      call hbook1(145,' var45--bkrd',50,0.,250.,0.)
      call hbook1(146,' var46--bkrd',50,-3.,3.,0.)
      call hbook1(147,' var47--bkrd',50,-3.,3.,0.)
      call hbook1(148,' var48--bkrd',50,-3.,3.,0.)
      call hbook1(149,' var49--bkrd',50,-3.,3.,0.)
      call hbook1(150,' var50--bkrd',50,0.,4.,0.)
      call hbook1(151,' var51--bkrd',50,0.,550.,0.)
      call hbook1(152,' var52--bkrd',50,0.,1100.,0.)
      call hbook1(153,' var53--shift1--bkrd',50,0.,300.,0.)
      call hbook1(154,' var54--shift2--bkrd',50,0.,300.,0.)
      call hbook1(155,' var55--bkrd',50,-1.,1.,0.)
      call hbook1(156,' var56--bkrd',50,0.,1.05,0.)
      call hbook1(157,' var57--bkrd',50,0.,1.05,0.)
      call hbook1(158,' var58--bkrd',50,0.,25.,0.)
      call hbook1(159,' var59--bkrd',50,0.,12.,0.)
      call hbook1(160,' var60--bkrd',50,0.,100.,0.)
      call hbook1(161,' var61--bkrd',50,0.,12.,0.)
      call hbook1(162,' var62--bkrd',50,0.,50.,0.)
      call hbook1(163,' var63--bkrd',50,0.,10000.,0.)
      call hbook1(164,' var64--bkrd',50,0.,10000.,0.)
      call hbook1(165,' var65--bkrd',50,0.,.2,0.)
      call hbook1(166,' var66--bkrd',50,0.,.2,0.)
      call hbook1(167,' var67--bkrd',50,0.,12.,0.)
      call hbook1(168,' var68--bkrd',50,0.,12.,0.)
      call hbook1(169,' var69--bkrd',50,0.,20.,0.)
      call hbook1(170,' var70--bkrd',50,0.,50.,0.)
      call hbook1(171,' var71--bkrd',50,0.,50.,0.)
      call hbook1(201,' score for signal test events',50,-15.,15.,0.)
      call hbook1(202,' score for background test events',50,-15.
     +                                                    ,15.,0.)
      return
 10   continue
c  Here to readout histograms
      call hcdir('//outh',' ')
      call hrout(0,icyc,'T')
      call hrend('//outh')
      return
      end
c-----------------------------------------------------------------------
      real function myran_sing(dum)
      implicit none
      integer len
      parameter (len=100)
      real dum,ranvec(len)
      integer irvec
      save irvec
      external ranlux
      data irvec/101/
      if (irvec .gt. len) then
         call ranlux(ranvec,len)
         irvec = 1
      end if
      myran_sing = ranvec(irvec)
      irvec = irvec + 1
c      write(*,*) 'irvec,ran',irvec,ranvec(irvec-1)
      return
      end
c-----------------------------------------------------------------------
      subroutine output_var (this_var,value)
      implicit none
      real value
      integer num_var,this_var
      parameter(num_var = 57)
      real xntupl(num_var)
      character*8 chtags(num_var)
      data chtags/'ntrainsg','ntrainbk','tree','nsig1','nsig2'         !1
     +     ,'nsig3','nsig4','nsig5','nsig6','nsig7','nsig8'            !6
     +     ,'nsig8','nbkd1','nbkd2','nbkd3','nbkd4','nbkd5'            !12
     +     ,'nbkd6','nbkd7','nbkd8','nbkd9','score1','score2'          !18
     +     ,'score3','score4','score5','score6','score7','score8'      !24
     +     ,'score9','frsig1','frsig2','frsig3','frsig4','frsig5'      !30
     +     ,'frsig6','frsig7','frsig8','frsig9','frbkd1','frbkd2'      !36
     +     ,'frbkd3','frbkd4','frbkd5','frbkd6','frbkd7','frbkd8'      !42
     +     ,'frbkd9','ratio1','ratio2','ratio3','ratio4','ratio5'      !48
     +     ,'ratio6','ratio7','ratio8','ratio9'/                      !54
                                      
      if (this_var .eq. 0) then
c   Here to initialize ntuple
         call hbookn(300,'BooNE  mc',num_var,'HSTOU',1000,chtags)
      else if (this_var .eq. -1) then
c   Here to output the ntuple for this event
         call hfn(300,xntupl)
       else if ((this_var.gt.0).and.(this_var.le.num_var)) then
c   Here to fill a location in the ntupl--ntupl uses real*4.
         xntupl(this_var) = value
      else
c   Here for error
         write(*,1000) this_var, num_var, value
 1000   format(' ','ERROR IN OUTPUT_VAR'/'this_var =',i5, '  num_var =',
     +       i4,'  value = ',d12.4)
        stop
      end if
      return
      end
c------------------------------------------------------------------------
